{{

        Emic2 / SidCog Sequencer Demo by Whisker of http://tymkrs.com/        

}}

CON
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000

  EMIC_TX       = 6                                  
  EMIC_RX       = 7                      
  
OBJ
  SID   :       "SIDCog"
  Emic2 :       "FullDuplexSerial"
  
VAR
  'SIDcog
  byte  buffer[25]
  byte  WaveOn
  byte  WaveOff

  long  X

Pub Main | Index

  Emic2.Start(EMIC_RX, EMIC_TX, %0000, 9_600)
  Emic2.TX(13)
  repeat until Emic2.RxCheck == ":" 

  Emic2.TX("V")                                       
  Emic2.TX("1")
  Emic2.TX("8")
  Emic2.TX(13)
  repeat until Emic2.RxCheck == ":"

  Emic2.TX("N")                                       
  Emic2.TX("5")
  Emic2.TX(13)
  repeat until Emic2.RxCheck == ":"

  SidCogInit
  repeat    
    repeat Index from 0 to 31
      Sing(Index)
      waitcnt(((clkfreq / 1000) * 250) + cnt)
      Seq(Index)

Pub SidCogInit | Index
  WaveOn := 129
  WaveOff := 128

  SID.start(26, 27)
  repeat Index from 0 to 24
    buffer[Index] := 0
  SID.updateRegisters(@buffer)
  
  buffer[24] := 1
   
  buffer[3] := 8
  buffer[10] := 8
  buffer[17] := 8

  'ADSR
  buffer[5] := (0 << 4) | 5
  buffer[6] := (0 << 4) | 0
  
  buffer[12] := (5 << 4) | 0
  buffer[13] := (15 << 4) | 7
  
  buffer[19] := (0 << 4) | 12
  buffer[20] := (4 << 4) | 9

  'Filter
  buffer[21] := 7
  buffer[22] := 255
  buffer[23] := (15 << 4) | 2
  buffer[24] := (2 << 4) | 1
  
  SID.updateRegisters(@buffer)
  
Pub Sing(Index)
  case Em[Index]
    1:
      Emic2.TX("S")
      case ||(X?//3)
        0: Emic2.Str(@E05)
        1: Emic2.Str(@E01)
        2: Emic2.Str(@E06)        
      Emic2.TX(13)
    2:
      Emic2.TX("S")
      Emic2.Str(@E02)
      Emic2.TX(13)
    3:
      Emic2.TX("S")
      Emic2.Str(@E03)
      Emic2.TX(13)
    4:
      Emic2.TX("S")
      Emic2.Str(@E04)
      Emic2.TX(13)
      
Pub Seq(Index) | VoiceIndex, ModWheel

  dira[16..23]~~

'off
  repeat VoiceIndex from 0 to 2
    case VoiceIndex
      0:
        if V1[Index] == 0
          buffer[4]  := WaveOff
      1:
        if V2[Index] == 0
          buffer[11] := WaveOff
      2:
        if V3[Index] == 0
          buffer[18] := WaveOff
  SID.updateRegisters(@buffer)

'on  
  repeat VoiceIndex from 0 to 2
    case VoiceIndex
      0:
        if V1[Index] == 255
          '
        else
          if V1[Index] > 0
            buffer[4]  := 129
            buffer[0]  := Lo[V1[Index] + 13]
            buffer[1]  := Hi[V1[Index] + 13]
            outa[16..23] := V1[Index]
      1:
        case ||(X?//7)
          0: ModWheel := 0
          1: ModWheel := 2
          2: ModWheel := 4
          3: ModWheel := 5
          4: ModWheel := 7
          5: ModWheel := 9
          6: ModWheel := 11
        if V2[Index] == 255
          '
        else             
          if V2[Index] > 0          
            buffer[11] := 65
            buffer[7]  := Lo[V2[Index] + 13 + ModWheel]
            buffer[8]  := Hi[V2[Index] + 13 + ModWheel]
            outa[16..23] := V2[Index]
      2:
        if V3[Index] == 255
            '
        else
         if V3[Index] > 0        
            buffer[18] := 33
            buffer[14] := Lo[V3[Index] + 13]
            buffer[15] := Hi[V3[Index] + 13]
            outa[16..23] := V3[Index]
  SID.updateRegisters(@buffer)   

  if Ri[Index] > 0 and Ri[Index] < 29
    buffer[Ri[Index]] := Rv[Index] 
  

Dat

V1      Byte  004, 000, 000, 032, 000, 032, 000, 000, 004, 000, 000, 032, 000, 032, 000, 000, 004, 000, 000, 032, 000, 032, 000, 000, 004, 000, 000, 032, 000, 032, 000, 000
V2      Byte  000, 000, 000, 012, 000, 024, 255, 255, 255, 255, 000, 024, 000, 036, 255, 255, 255, 255, 000, 036, 000, 024, 255, 255, 255, 255, 000, 024, 000, 012, 255, 000 
V3      Byte  012, 024, 000, 000, 007, 000, 007, 000, 012, 024, 000, 000, 007, 000, 007, 000, 012, 024, 000, 000, 007, 000, 007, 000, 012, 024, 000, 000, 007, 000, 007, 000
Em      Byte  001, 000, 000, 000, 000, 000, 000, 000, 002, 000, 000, 000, 000, 000, 000, 000, 003, 000, 000, 000, 000, 000, 000, 000, 004, 000, 000, 000, 000, 000, 000, 000

Ri      Byte  022, 006, 022, 006, 022, 006, 022, 006, 022, 006, 022, 006, 022, 006, 022, 006, 022, 006, 022, 006, 022, 006, 022, 006, 022, 006, 022, 006, 022, 006, 022, 006
Rv      Byte  007, 065, 015, 066, 031, 067, 063, 068, 127, 069, 255, 070, 127, 071, 063, 072, 031, 073, 015, 074, 007, 075, 015, 076, 031, 077, 064, 078, 031, 079, 015, 064   

E01     Byte  "[ay<350,25> kae<250,20> n<250,20>[:n0]", 0
E02     Byte  "[s<150,22>iy<500,18>ng<150,18>ng<150,20>[:n0]", 0
E03     Byte  "[tuw<150,20>uw<750,25>[:n0]", 0
E04     Byte  "[yx<150,18> uw<750,17>[:n0]", 0
E05     Byte  "[ehm<250,25>ihk<250,20> tuw<125,25>uw<250,20>[:n0]", 0
E06     Byte  "[ehm<250,25>ihk<250,20> kae<150,25> n<150,20>[:n0]", 0

Hi      Byte  001, 001, 001, 001, 001, 001, 001, 001, 001, 001, 001, 001, 002, 002, 002, 002, 002, 002, 002, 003, 003, 003, 003, 003, 004, 004, 004, 004, 005, 005, 005, 006, 006, 007, 007, 007, 008, 008, 009, 009, 010, 011, 011, 012, 013, 014, 014, 015, 016, 017, 018, 019, 021, 022, 023, 025, 026, 028, 029, 031, 033, 035, 037, 039, 042, 044, 047, 050, 053, 056, 059, 063, 067, 071, 075, 079, 084, 089, 094, 100, 106, 112, 119, 126, 134, 142, 150, 159, 168, 179, 189, 200, 212, 225, 238, 253
Lo      Byte  012, 028, 045, 062, 081, 102, 123, 145, 169, 195, 221, 250, 024, 056, 090, 125, 163, 204, 246, 035, 083, 134, 187, 244, 048, 112, 180, 251, 071, 152, 237, 071, 167, 012, 119, 233, 097, 225, 104, 247, 143, 048, 218, 143, 078, 024, 239, 210, 195, 195, 209, 239, 031, 096, 181, 030, 156, 049, 223, 165, 135, 134, 162, 223, 062, 193, 107, 060, 057, 099, 190, 075, 015, 012, 069, 191, 125, 131, 214, 121, 115, 199, 124, 151, 030, 024, 139, 126, 250, 006, 172, 243, 230, 143, 248, 046